# M2 Sample Module's Structure

This is just a sample, you can create your own module's structure by your own way.
This is a PHP Composer compatible module to be used in Magento v2 applications.
Module contains development instance of the Magento v2 application with module's sources are (sym)linked into 
this development instance.

    
* [cfg/](../cfg/): initial templates for configuration scripts processing;
* [docs/](../docs/): documentation root; 
* [live/](../live/): production/pilot environment root;
    * [composer.json](../live/composer.json): PHP Composer descriptor for project;
     * [templates.cfg.json](../live/templates.cfg.json): configuration for templates processing 
     (source templates paths, targets paths, composer events, etc).
     * [templates.vars.json.init](../live/templates.vars.json.init): source for templates variables; 
* [src/](../src/): Magento 2 module's sources;
* [test/](../test/): modules's test sources and scripts;
* [work/](../work/): development environment root;
    * [test/](../work/test/): development tests;
        * [functional/](../work/test/functional/): PHPUnit configuration to launch functional tests (use real M2 App objects);
        * [fw/](../work/test/fw/): framework scripts for functional tests;
        * [unit/](../work/test/unit/): PHPUnit configuration to launch unit tests (use mocks);
    * [composer.json](../work/composer.json): PHP Composer descriptor for project;
     * [templates.cfg.json](../work/templates.cfg.json): configuration for templates processing 
     (source templates paths, targets paths, composer events, etc).
     * [templates.vars.json.init](../work/templates.vars.json.init): source for templates variables;
     * [templates.vars.json.travis](../work/templates.vars.json.travis): template variables for Travis CI;